var y x ;
varexo eps ;

parameters rhox sigma	beta theta xb ;

rhox 	=0.9;// -0.139;//
sigma	=0.0153;//0.0348;//
beta 	=0.950;
theta = -1.500;//-10;//
xb		= 0.0179;


model ;//(bytecode);//(block) ;
y = beta*exp(theta*x(+1))*(1+y(+1));
x= rhox*x(-1) + (1-rhox)*xb+eps;
end;


// Steady state (analytically solved)
initval;
eps=0;
x=xb;
y=beta*exp(theta*xb)/(1-beta*exp(theta*xb));
end;

// Check that this is indeed the steady state
steady;

// Check the Blanchard-Kahn conditions
check;

// Declare a positive technological shock in period 1
shocks;
var eps;
periods 1;
values -0.175705683822857;//-0.1757;//-0.1740;//5*0.0348; 0.2460;//
end;

// Deterministic simulation of the model for 200 periods
simul(periods=400,stack_solve_algo =0);

// Display the path of consumption and capital

//rplot x;
//rplot y;
//figure;//spy(oo_.endo_simul);
//plot (x, y);

//steady_state_model;
//x=xb;
//y=beta*exp(theta*xb)/(1-beta*exp(theta*xb));
//end;

