
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Viktors Ajevskis. Semi-Global Solutions to DSGE Models:Perturbation around
%a Deterministic Path.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
dynare asset_deterministic;

%Define parameters
syms XBAR RHO THETA BETTA

%Define variables 
syms p pp a ap
     
%Write equations (e1 and e2)
e1 = -p + BETTA * (1 + pp) * exp(THETA * ap);

%e2 = -ap + (1-RHO) * XBAR + RHO * a;

%Create function f
f = [e1];%e2];%f3];

% Define the vector of controls, y, and states, x

% Define the vector of controls, y, and states, x

% x1=p;
% x1p=pp;
x2p=ap;
x2 = a;

y = p;
yp = pp;


ny = size(y,2);
%nxp = size(xp,2);
nyp = size(yp,2);
 nx1=0;%size(x1,2);
nx1p=0;%size(x1p,2);
nx2p=size(x2p,2);
nx2=size(x2,2);


n = size(f,1);

%Compute the first and second derivatives of f

fx2=jacobian(f,x2);
fx2p=jacobian(f,x2p);

fy = jacobian(f,y);
fyp = jacobian(f,yp);


XBAR = 0.0179; %steady state of growth rate of dividend process
 
RHO =-0.139; %persistence parameter of growth rate of dividend process
% 


eta=0.0348; %Matrix multiplying the vector of innovations
sx		= eta/sqrt(1-RHO*RHO);
sig = 1; %parameter scaling the vector of innovations
% Steady-state price-Divident ratio, p, is the only endogenous variable
EXP=[ 
    %0.950 -1.500 0.0348 -0.139];
%    0.500 -1.500 0.0348 -0.139;
   % 0.990 -1.500 0.0348 -0.139];
  %  0.950 -10.00 0.0348 -0.139];
    %0.950 -5.00 0.0348 -0.139];
  %  0.950  0.000 0.0348 -0.139];
  %  0.950  0.500 0.0348 -0.139];
%    0.950 -1.500 0.0010 -0.139];
  %   0.950 -1.500 0.1000 -0.139];
 %   0.950 -1.500 sx      0];
   %0.950 -1.500 sx*sqrt(0.75) 0.5];
  % 0.950 -5 sx*sqrt(0.75) 0.5];
 0.950 -1.500 sx*sqrt(0.19) 0.9];
  %0.950 -5.00 0.0348 0.5];
  k = 1;
BETTA	= EXP(k,1);
THETA = EXP(k,2);
XBAR	= 0.0179;
RHO	= EXP(k,4);
eta	= EXP(k,3);


  
  
s=load('asset_deterministic_results');
% y_t and x_t

p_t=s.oo_.endo_simul(1,2:end-1); 
a_t=s.oo_.endo_simul(2,2:end-1);
%Next-period variables
pp_t = s.oo_.endo_simul(1,3:end);
ap_t =s.oo_.endo_simul(2,3:end);


% x1_t=p_t;
x2_t=a_t;
y_t = p_t;
%xp = [kp ap];
% x1p_t=pp_t;
x2p_t=ap_t;
yp_t = pp_t;


 T=size(s.oo_.endo_simul(1,2:end-1),2);

 
   nfx2 = zeros([size(fx2) T] );
 nfx2p = zeros([size(fx2p) T] );
  
  nfy=zeros([size(fy) T] );
   nfyp=zeros([size(fyp) T] );
   
    for t=1:T
     p=p_t(t);

         a=a_t(t);
           pp=pp_t(t);

         ap=ap_t(t);
%          

      
%       nfx1_=zeros(size(fx1));
%      nfx1_(:)=eval(fx1(:));
%       nfx1(:,:,t)=nfx1_;
%       
%        nfx1p_=zeros(size(fx1p));
%      nfx1p_(:)=eval(fx1p(:));
%       nfx1p(:,:,t)=nfx1p_;
      
       nfx2_=zeros(size(fx2));
     nfx2_(:)=eval(fx2(:));
      nfx2(:,:,t)=nfx2_;
      
       nfx2p_=zeros(size(fx2p));
     nfx2p_(:)=vpa(subs(fx2p(:)));
      nfx2p(:,:,t)=nfx2p_;
      
       nfy_=zeros(size(fy));
     nfy_(:)=eval(fy(:));
      nfy(:,:,t)=nfy_;
      
      nfyp_=zeros(size(fyp));
     nfyp_(:)=eval(fyp(:));
      nfyp(:,:,t)=nfyp_;
    end
   


Phi_t=zeros(ny+nx1,ny+nx1,T);
Lamda_t=zeros(ny+nx1,ny+nx1,T);

LM_t=zeros(ny+nx1,ny+nx1,T);
L1=zeros(ny+nx1,ny+nx1,T);
T1=zeros(ny+nx1,ny+nx1,T);
U=zeros(ny+nx1,ny+nx1,T);
P=zeros(ny+nx1,ny+nx1,T);
Z=zeros(ny+nx1,ny+nx1,T);
Pi_t=zeros(ny+nx1,nx2,T);
Pir_t = zeros(ny+nx1,nx2,T);


for k = 1:1:T
Phi_t(:,:,k) = [ -nfyp(:,k)] ; % \Phi_t %-nfx1p(:,k)
Lamda_t(:,:,k)  = [nfy(:,k)] ; % \Lambda_t %nfx1(:,k) 
LM_t(:,:,k)=Phi_t(:,:,k)\Lamda_t(:,:,k);%\Phi_t\Lambda_t
%Coefficients for exogenuous variable z_t

Pi_t(:,k) = Phi_t(:,:,k)\(nfx2p(:,k)*RHO+nfx2(:,k)); % \Phi_t\(f_{5,t}\Lambda+f_{6,t})

Pir_t (:,k) = Phi_t(:,:,k)\nfx2p(:,k);% \Phi_t\f_{6,t}
end
% Schur decomposition
L=LM_t(:,:,end);
[s1,t1,q1,z1] = qz(eye(ny+nx1,ny+nx1),L(:,:,end)) ;
[s1,t1,q1,z1]  = qzdiv(1 + 1e-6,s1,t1,q1,z1);  
L1=s1\t1;

% Block-diagonal Schur decomposition
% BLKS = [nx1;ny];

% [Z2,P2] = bdschur(L1,[],BLKS);
  [Z2,P2] = bdschur(L1);
 %transformation matrix
 Z=z1*Z2;
 Z_11=Z(1:nx1,1:nx1);
  Z_12=Z(1:nx1,nx1+1:end);
  Z_21=Z(nx1+1:end,1:nx1);
 Z_22=Z(nx1+1:end,nx1+1:end);
 
 Z_= Z2\s1\q1;
 
Z_t=zeros(ny+nx1,ny+nx1,T);
M=zeros(ny+nx1,ny+nx1,T);
for k=1:T

M(:,:,k) =Z_*(LM_t(:,:,k) -L)*z1*Z2;
Pi_t(:,k)=Z_*Pi_t(:,k);
Pir_t (:,k)=Z_* Pir_t (:,k);
   Z_t(:,:,k)=- Z_ *Phi_t(:,:,k)^-1;
end

Q=zeros(ny+nx1,ny+nx1,T);
Q11_t=M(1:nx1,1:nx1,: );
Q22_t=M(nx1+1:ny+nx1,nx1+1:ny+nx1,: );
Q12_t=M(1:nx1,nx1+1:ny+nx1,: );
Q21_t=M(nx1+1:ny+nx1,1:nx1,: );
 A_t=zeros(nx1,nx1,T); % A_t_{T}
B_t=zeros(ny,ny,T); % B_t_{T}
for k=1:T
A_t(:,:,k)=P2(1:nx1,1:nx1)+Q11_t(:,:,k);
B_t(:,:,k)=P2(nx1+1:ny+nx1,nx1+1:ny+nx1)+Q22_t(:,:,k);
end

Pi1_t = zeros(1,1,T+1);%Pi_t(1,:,:);
Pi2_t =  Pi_t;%(1,:,:);% [];%
R_t=zeros(ny,nx2,T+1);

% K_t(:,:,T+1)=0; %K_{T+1}
K_t=zeros(ny,nx1,T+1);
 L_t=zeros(ny,ny,T+1);
for i=1:T
        L_t(:,:,T-i+1)=B_t(:,:,T-i+1)+K_t(:,:,T-i+2)*Q12_t(:,:,T-i+1) ;  %  L_{t,T+1}
 
       R_t(:,:,T-i+1)= L_t(:,:,T-i+1)\(Pi2_t(:,:,T-i+1) + R_t(:,:,T-i+2)*RHO ); %+ K_t(:,:,T-i+2)*Pi1_t(:,:,T-i+1) 
end

 Al_t=zeros(nx1,nx1,T);% \mathbb{A}_{t}
 Pil_t=zeros(nx1,nx2,T);% \mathbb{P}_{t} 
 
for k=1:T
Al_t(:,:,k)  = A_t(:,:,k) -Q12_t(:,:,k)*K_t(:,:,k) ;
Pil_t(:,:,k) = - Q12_t(:,:,k)*R_t(:,:,k)+  Pi1_t(:,:,k);
end
Rl_t1= Pir_t (1:nx1,:,:)  ; % \mathbb{R}_{1,t}

 gamma=zeros(nx1,nx2,T,T); %\gamma_{t-1,t-i}
 gamma(:,:,1,1)= Rl_t1(:,:,1);

for t=2:T
    
    for i=1:t-1
        
        gamma(:, :,t,i ) = Al_t(:,:,t-1)* gamma(:, :,t-1, i ) + Pil_t(:,:,t-1)*RHO^(i-1)  ;
                
    end
    
    gamma(:,:,t,t)=Rl_t1(:,:,t);
end
delta1 = zeros(ny,nx2,T,T);


for t=1:T
    for j=1:t
    
delta1(:,:,t,j) = - K_t(:,:,t)*gamma(:, :,t, j ) - R_t(:,:,t) *RHO^(t-j);

    end
end

%rho_x=Z_11*gamma+Z_12*delta1;
rho_y=+Z_22.*delta1; %Z_21*gamma

% if approx==2

fypyp = reshape(jacobian(fyp(:),yp),n,nyp,nyp);

fypy = reshape(jacobian(fyp(:),y),n,nyp,ny);

%fypxp = reshape(jacobian(fyp(:),xp),n,nyp,nxp);

% fypx1p = reshape(jacobian(fyp(:),x1p),n,nyp,nx1p);
fypx2p = reshape(jacobian(fyp(:),x2p),n,nyp,nx2p);
%fypx = reshape(jacobian(fyp(:),x),n,nyp,nx);

%fypx1 = reshape(jacobian(fyp(:),x1),n,nyp,nx1);
fypx2 = reshape(jacobian(fyp(:),x2),n,nyp,nx2);
fyyp = reshape(jacobian(fy(:),yp),n,ny,nyp);

fyy = reshape(jacobian(fy(:),y),n,ny,ny);

%fyx1p = reshape(jacobian(fy(:),x1p),n,ny,nx1p);
fyx2p = reshape(jacobian(fy(:),x2p),n,ny,nx2p);

%fyx1 = reshape(jacobian(fy(:),x1),n,ny,nx1);
fyx2 = reshape(jacobian(fy(:),x2),n,ny,nx2);

%fx1pyp = reshape(jacobian(fx1p(:),yp),n,nx1p,nyp);
fx2pyp = reshape(jacobian(fx2p(:),yp),n,nx2p,nyp);


%fx1py = reshape(jacobian(fx1p(:),y),n,nx1p,ny);
fx2py = reshape(jacobian(fx2p(:),y),n,nx2p,ny);


%fx1px1p = reshape(jacobian(fx1p(:),x1p),n,nx1p,nx1p);
fx2px2p = reshape(jacobian(fx2p(:),x2p),n,nx2p,nx2p);
%fx1px2p = reshape(jacobian(fx1p(:),x2p),n,nx1p,nx2p);
%fx2px1p = reshape(jacobian(fx2p(:),x1p),n,nx2p,nx1p);

%fx1px1 = reshape(jacobian(fx1p(:),x1),n,nx1p,nx1);
fx2px2= reshape(jacobian(fx2p(:),x2),n,nx2p,nx2);
%fx1px2 = reshape(jacobian(fx1p(:),x2),n,nx1p,nx2);
%fx2px1 = reshape(jacobian(fx2p(:),x1),n,nx2p,nx1);



%fx1yp = reshape(jacobian(fx1(:),yp),n,nx1,nyp);
fx2yp = reshape(jacobian(fx2(:),yp),n,nx2,nyp);


%fx1y = reshape(jacobian(fx1(:),y),n,nx1,ny);
fx2y = reshape(jacobian(fx2(:),y),n,nx2,ny);


%fx1x1p = reshape(jacobian(fx1(:),x1p),n,nx1,nx1p);
fx2x2p = reshape(jacobian(fx2(:),x2p),n,nx2,nx2p);
%fx1x2p = reshape(jacobian(fx1(:),x2p),n,nx1,nx2p);
%fx2x1p = reshape(jacobian(fx2(:),x1p),n,nx2,nx1p);

%fx1x1 = reshape(jacobian(fx1(:),x1),n,nx1,nx1);
fx2x2 = reshape(jacobian(fx2(:),x2),n,nx2,nx2);
%fx1x2 = reshape(jacobian(fx1(:),x2),n,nx1,nx2);
%fx2x1 = reshape(jacobian(fx2(:),x1),n,nx2,nx1);

% else
% 
% fypyp=0; fypy=0; fypxp=0; fypx=0; fyyp=0; fyy=0; fyxp=0; fyx=0; fxpyp=0; fxpy=0; fxpxp=0; fxpx=0; fxyp=0; fxy=0; fxxp=0; fxx=0;
% 
% end    
    nfypyp=zeros([size(fypyp) T]);
    nfypy=zeros([size(fypy) T]);

% nfypx1=zeros([size(fypx1) T]);

% 
%
% nfypx2=zeros([size(fypx2) T]);

nfypx2p=zeros([size(fypx2p) T]);

 nfyyp=zeros([size(fyyp) T]);

% 
 nfyy=zeros([size(fyy) T]);
nfyx2 = zeros([size(fyx2) T]);
%nfyx1= zeros([size(fyx1) T]);
%nfyx1p= zeros([size(fyx1p) T]);
 nfyx2p = zeros([size(fyx2p) T]);

% 
 %nfx1pyp=zeros([size(fx1pyp) T]);

% 
 %nfx1py=zeros([size(fx1py) T]);

% 
 %nfx1px1p=zeros([size(fx1px1p) T]);

% 
 %nfx1px1=zeros([size(fx1px1) T]);

% 
 %nfx1yp=zeros([size(fx1yp) T]);

% 
 %nfx1y=zeros([size(fx1y) T]);

% 
% nfx1x1p=zeros([size(fx1x1p) T]);

% 
 %nfx1x1=zeros([size(fx1x1) T]);
    
 %nfx1px2p=zeros([size(fx1px2p) T]);
 %nfx2px1p=zeros([size(fx2px1p) T]);
 %nfx1px2=zeros([size(fx1px2) T]);
  %nfx2x1p=zeros([size(fx2x1p) T]);
% nfx1x2p=zeros([size(fx1x2p) T]);
 %nfx2px1=zeros([size(fx2px1) T]);
% nfx1x2=zeros([size(fx1x2) T]);
%  nfx2x1=zeros([size(fx2x1) T]);
    
     nfx2pyp=zeros([size(fx2pyp) T]);

% 
 nfx2py=zeros([size(fx2py) T]);

% 
 nfx2px2p=zeros([size(fx2px2p) T]);

% 
 nfx2px2=zeros([size(fx2px2) T]);

% 
 nfx2yp=zeros([size(fx2yp) T]);

% 
 nfx2y=zeros([size(fx2y) T]);

% 
 nfx2x2p=zeros([size(fx2x2p) T]);

% 
 nfx2x2=zeros([size(fx2x2) T]);

    
 for t=1:T
    p=p_t(t);

         a=a_t(t);
           pp=pp_t(t);

         ap=ap_t(t);       
                   
      nfypyp_ = zeros(size(fypyp));
            nfypyp_(:) = eval(fypyp(:) ); 
                         nfypyp(:,:,t)=  Z_t(:,:,t)*nfypyp_ ;
                               
          nfypy_= zeros(size(fypy));
              nfypy_(:) = eval(fypy(:) );
        nfypy(:,:,t) =Z_t(:,:,t)* nfypy_;
        
          nfyy_=zeros(size(fyy));
              nfyy_(:) =eval(fyy(:) );
        nfyy(:,:,t)=Z_t(:,:,t)*nfyy_;
        
         nfyyp_=zeros(size(fyyp));
              nfyyp_(:) =eval(fyyp(:) );
        nfyyp(:,:,t)=Z_t(:,:,t)*nfyyp_;
        
%         
%          nfypx1_=zeros(size(fypx1));
%       nfypx1_(:) =eval((fypx1(:) ));
%       nfypx1(:,:,t)=Z_t(:,:,t)*nfypx1_;
%       
%       
%         nfypx1p_=zeros(size(fypx1p));
%       nfypx1p_(:) =eval((fypx1p(:) ));
%       nfypx1p(:,:,t)=Z_t(:,:,t)*nfypx1p_;
%       
%       nfx1pyp_=zeros(size(fx1pyp));
%       nfx1pyp_(:) =eval((fx1pyp(:) ));
%       nfx1pyp(:,:,t)=Z_t(:,:,t)*nfx1pyp_;       
%       
%       
%        nfyx1_=zeros(size(fyx1));
%       nfyx1_(:) =eval((fyx1(:) ));
%       nfyx1(:,:,t)=Z_t(:,:,t)*nfyx1_;
%       
%         nfx1y_=zeros(size(fx1y));
%       nfx1y_(:) =eval((fx1y(:) ));
%       nfx1y(:,:,t)=Z_t(:,:,t)*nfx1y_;
%       
%         nfyx1p_=zeros(size(fyx1p));
%       nfyx1p_(:) =eval((fyx1p(:) ));
%       nfyx1p(:,:,t)=Z_t(:,:,t)*nfyx1p_;
%       
%        nfx1py_=zeros(size(fx1py));
%       nfx1py_(:) =eval((fx1py(:) ));
%       nfx1py(:,:,t)=Z_t(:,:,t)*nfx1py_;
           
       %%%%%%%%%%%%%%%%%%%%%%%%%%%
     nfypx2_=zeros(size(fypx2));
      nfypx2_(:) =eval((fypx2(:) ));
      nfypx2(:,:,t)=Z_t(:,:,t)*nfypx2_;
      
      
        nfypx2p_=zeros(size(fypx2p));
      nfypx2p_(:) =eval((fypx2p(:) ));
      nfypx2p(:,:,t)=Z_t(:,:,t)*nfypx2p_;
      
      nfx2pyp_=zeros(size(fx2pyp));
      nfx2pyp_(:) =eval((fx2pyp(:) ));
      nfx2pyp(:,:,t)=Z_t(:,:,t)*nfx2pyp_;
      
           
       nfyx2_=zeros(size(fyx2));
      nfyx2_(:) =eval((fyx2(:) ));
      nfyx2(:,:,t)=Z_t(:,:,t)*nfyx2_;
      
        nfx2y_=zeros(size(fx2y));
      nfx2y_(:) =eval((fx2y(:) ));
      nfx2y(:,:,t)=Z_t(:,:,t)*nfx2y_;
      
        nfyx2p_=zeros(size(fyx2p));
      nfyx2p_(:) =eval((fyx2p(:) ));
      nfyx2p(:,:,t)=Z_t(:,:,t)*nfyx2p_;
      
       nfx2py_=zeros(size(fx2py));
      nfx2py_(:) =eval((fx2py(:) ));
      nfx2py(:,:,t)=Z_t(:,:,t)*nfx2py_;
      
      %%%%%%%%%%%%%%%%
%          nfx1px1p_=zeros(size(fx1px1p));
%       nfx1px1p_(:) =eval((fx1px1p(:) ));
%       nfx1px1p(:,:,t)=Z_t(:,:,t)*nfx1px1p_;
%       
%       nfx1px1_=zeros(size(fx1px1));
%       nfx1px1_(:) =eval((fx1px1(:) ));
%       nfx1px1(:,:,t)=Z_t(:,:,t)*nfx1px1_;
%       
%       nfx1x1p_=zeros(size(fx1x1p));
%       nfx1x1p_(:) =eval((fx1x1p(:) ));
%       nfx1x1p(:,:,t)=Z_t(:,:,t)*nfx1x1p_;
%       
%        nfx1px2p_=zeros(size(fx1px2p));
%       nfx1px2p_(:) =eval((fx1px2p(:) ));
%       nfx1px2p(:,:,t)=Z_t(:,:,t)*nfx1px2p_;
%       
%        nfx2px1p_=zeros(size(fx2px1p));
%       nfx2px1p_(:) =eval((fx2px1p(:) ));
%       nfx2px1p(:,:,t)=Z_t(:,:,t)*nfx2px1p_;
%       
%        nfx1px2_=zeros(size(fx1px2));
%       nfx1px2_(:) =eval((fx1px2(:) ));
%       nfx1px2(:,:,t)=Z_t(:,:,t)*nfx1px2_;
%       
%       nfx2x1p_=zeros(size(fx2x1p));
%       nfx2x1p_(:) =eval((fx2x1p(:) ));
%       nfx2x1p(:,:,t)=Z_t(:,:,t)*nfx2x1p_;
      
%        nfx1x1_=zeros(size(fx1x1));
%       nfx1x1_(:) =eval((fx1x1(:) ));
%       nfx1x1(:,:,t)=Z_t(:,:,t)*nfx1x1_;
%       
%        nfx1x2p_=zeros(size(fx1x2p));
%       nfx1x2p_(:) =eval((fx1x2p(:) ));
%       nfx1x2p(:,:,t)=Z_t(:,:,t)*nfx1x2p_;
%       
%      
%         nfx2px1_=zeros(size(fx2px1));
%       nfx2px1_(:) =eval((fx2px1(:) ));
%       nfx2px1(:,:,t)=Z_t(:,:,t)*nfx2px1_;
%       
%       
%          nfx1x2_=zeros(size(fx1x2));
%       nfx1x2_(:) =eval((fx1x2(:) ));
%       nfx1x2(:,:,t)=Z_t(:,:,t)*nfx1x2_;
%       
%      
%         nfx2x1_=zeros(size(fx2x1));
%       nfx2x1_(:) =eval((fx2x1(:) ));
%       nfx2x1(:,:,t)=Z_t(:,:,t)*nfx2x1_;
      
       nfx2px2p_=zeros(size(fx2px2p));
      nfx2px2p_(:) =eval((fx2px2p(:) ));
      nfx2px2p(:,:,t)=Z_t(:,:,t)*nfx2px2p_;
      
       nfx2px2_=zeros(size(fx2px2));
      nfx2px2_(:) =eval((fx2px2(:) ));
      nfx2px2(:,:,t)=Z_t(:,:,t)*nfx2px2_;
      
       nfx2x2p_=zeros(size(fx2x2p));
      nfx2x2p_(:) =eval((fx2x2p(:) ));
      nfx2x2p(:,:,t)=Z_t(:,:,t)*nfx2x2p_;
      
        nfx2x2_=zeros(size(fx2x2));
      nfx2x2_(:) =eval((fx2x2(:) ));
      nfx2x2(:,:,t)=Z_t(:,:,t)*nfx2x2_;
 end
 
%delta = K_t*(gamma+RHO);
Omega=1;  % Covariance if innovations
Dx2=zeros(1,T+1);% variance of x2

for t=2:1:T+1
    Dx2(t)=RHO*Dx2(t-1)*RHO'+Omega;
end
 
%Variance of y(t)
Dy=zeros(1,T+1);

for t=1:1:T
    for i=1:t
        
    Dy(t)=rho_y(:,:,t,i) *Omega*rho_y(:,:,t,i)'+Dy(t);
    end
    end
%Variance of x(t)
% Dx1=zeros(1,T+1);
% for t=1:1:T
%     for i=1:t
%     Dx1(t)=rho_x(:,:,t,i) *Omega*rho_x(:,:,t,i)'+Dx1(t);
%     end
% end
    
%CoVariance of y(t)and x2(t)
Dyx2=zeros(1,T+1);

for t=1:1:T
    for i=2:t 
    Dyx2(t)=rho_y(:,:,t,i)*Omega*RHO'^(t-i)+Dyx2(t);
    end
end
 
    
%CoVariance of x1(t)and x2(t)
% Dx1x2=zeros(1,T+1);
% 
% for t=1:1:T
%     for i=1:t 
%     Dx1x2(t)=rho_x(:,:,t,i)*Omega*RHO'^(t-i)+Dx1x2(t);
%     end
% end
%     %CoVariance of y(t)and x1(t)
% Dyx1=zeros(1,T+1);
% 
% for t=1:1:T
%     for i=1:t 
%     Dyx1(t)=rho_y(:,:,t,i)*Omega*rho_x(:,:,t,i)'+Dyx1(t);
%     end
% end
% 
% eta
% % %
for t=1:T
   for i=1:n
              ypnfypypyp(i,t) = trace(nfypyp(i,:,t)./2*Dy(:,t));
     %  x1pnfx1px1pyx1p(i)= trace(nfx1px1p(i,:,t)*Dx1(:,t));
       x2pnfx2px2px2p(i,t)= trace(nfx2px2p(i,:,t)./2*Dx2(:,t+1));
       %%%
           %  ypnfypx1px1p(i)= trace(nfypx1p(i,:,t)*Dyx1(:,t));
             ypnfypx2px2p(i,t)= trace(nfypx2p(i,:,t)*Dyx2(:,t+1));
             %x1pnfx1px2px2p(i)= trace(nfx1px2p(i,:,t)*Dx1x2(:,t));
             %%%%%%%%%
              %ynfyyy(i,t)= trace(nfyy(i,:,t)*Dy(:,t-1));
             % x1nfx1x1yx1(i)= trace(nfx1x1(i,:,t)*Dx1(:,t-1));
              %x2nfx2x2x2(i,t)= trace(nfx2x2(i,:,t)*Dx2(:,t-1));
              %%%%%%%
           %  x1nfx1x2x2(i)= trace(nfx1x2(i,:,t)*Dx1x2(:,t-1));
              % eta = 1/2*yp(i,t)'*nfypyp(:,:,t)*yp(i,t );
   end
eta_0(i,t) =  +x2pnfx2px2px2p(i,t)+ypnfypx2px2p(i,t)  ;%x1pnfx1px1pyx1p++ypnfypx1px1p+x1pnfx1px2px2px1nfx1x1yx1+x1nfx1x2x2+(1:n,t) 
%+ynfyyy(i,t)./2 +...x2nfx2x2x2(i,t)./2ypnfypypyp(i,t)./2
     eta1(:,t)=eta_0(:,t);
     vu(t)=eta1(1,t);
     
end
vs=zeros(1,T);% eta1(1,:);
% vu=eta1(1,:);


g = zeros(ny,T+1);
g(:,T) =B_t(:,:,T)\vu(:,T);
%stochastic steady state, 
g(:,T+1) = (1-inv(B_t(:,:,end)))\inv(B_t(:,:,end))*(1/2*THETA^2*(1+yp_t (end))*Dx2(2)+THETA*Dyx2(2));
% g(:,T+1) may be also zero
for i=1:T
    %aa(:,T-i+1)=L_t(:,:,T-i+2)\ vu(:,T-i+1);
    g(:,T-i+1) = L_t(:,:,T-i+1)\(  vu(:,T-i+1) +g(T-i+2)); %+  K_t(:,:,T-i+1)*vs(:,T-i+1) 
        
end



y_0= (Z_22+K_t(:,:,2)*Z_12)\g(1);

s_t=zeros();

u_t=zeros();

for t=1:T
%    s_t(t)=Al_t(:,:,t)*s_t(t-1)+ Q12_t(:,:,t)*vu(t)+vs(t);
    u_t(t)=+ g(t);  %K_t(:,:,t)*s_t (t)
    
    y_2(t) = Z_22*u_t(t);
end
    
%x_t(t)=Z_11*s_t(t)+Z_12*u_t(t);

y_pert = p_t + eta^2.*y_2;

plot(a_t(1:end),y_pert(1:end));


